GraphIncIt< GR, Item, Base, sel > Class Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Member Functions
GraphIncIt< GR, Item, Base, sel > Class Template Reference

## Detailed Description

### template<typename GR, typename Item = typename GR::Arc, typename Base = typename GR::Node, char sel = '0'>
class lemon::concepts::GraphIncIt< GR, Item, Base, sel >

This class describes the concept of `InArcIt`, `OutArcIt` and `IncEdgeIt` subtypes of digraph and graph types.

Note
  Since these iterator classes do not inherit from the same base class, there is an additional template parameter (selector) `sel`. For `InArcIt` you should instantiate it with character `'i'`, for `OutArcIt` with `'o'` and for `IncEdgeIt` with `'e'`.

`#include <lemon/concepts/graph_components.h>`

Inherits Item.

## Public Member Functions
| GraphIncIt ()
| Default constructor. More...
| GraphIncIt (const GraphIncIt &it)
| Copy constructor. More...
| GraphIncIt (const GR &, const Base &)
| Constructor that sets the iterator to the first incoming or outgoing arc. More...
| GraphIncIt (Invalid)
| Constructor for conversion from `INVALID`. More...
GraphIncIt & | operator= (const GraphIncIt &)
| Assignment operator. More...
GraphIncIt & | operator++ ()
| Increment the iterator. More...
bool | operator== (const GraphIncIt &) const
| Equality operator. More...
bool | operator!= (const GraphIncIt &) const
| Inequality operator. More...

## Constructor & Destructor Documentation

GraphIncIt | ( |  | ) |
| inline

Default constructor.

Warning
  The default constructor is not required to set the iterator to some well-defined value. So you should consider it as uninitialized.

GraphIncIt | ( | const GraphIncIt< GR, Item, Base, sel > & | it | ) |
| inline

Copy constructor.

GraphIncIt | ( | const GR & | ,
|  | const Base & |
| ) |  |
| inlineexplicit

Constructor that sets the iterator to the first arc incoming to or outgoing from the given node.

GraphIncIt | ( | Invalid |  | ) |
| inline

Constructor for conversion from `INVALID`. It initializes the iterator to be invalid.

See Also
  Invalid for more details.

## Member Function Documentation

GraphIncIt& operator= | ( | const GraphIncIt< GR, Item, Base, sel > & |  | ) |
| inline

Assignment operator for the iterator.

GraphIncIt& operator++ | ( |  | ) |
| inline

This operator increments the iterator, i.e. assigns it to the next arc incoming to or outgoing from the given node.

bool operator== | ( | const GraphIncIt< GR, Item, Base, sel > & |  | ) | const
| inline

Equality operator. Two iterators are equal if and only if they point to the same object or both are invalid.

bool operator!= | ( | const GraphIncIt< GR, Item, Base, sel > & |  | ) | const
| inline

Inequality operator. Two iterators are equal if and only if they point to the same object or both are invalid.